def CI_PROJECT_DIR="./app/"
def CI_PROJECT_DIR_LB="./nginx/"
def CI_DEPLOY_USER="wilsongmn"
def CI_DEPLOY_CREDENTIAL="dockerhub"   
def CI_REGISTRY="docker.io"
def APP_IMAGE_NAME="devsuapp"
def LB_IMAGE_NAME="nginx-docker"

def GITHUB_USER="wilsonGmn"
def REPO_NAME="devsuapp"
def USER_CREDENTIAL="github"
def REPO_BRANCH="master"


pipeline {

    environment { 
        registry = "${CI_DEPLOY_USER}/${REPONAME}" 
        registryCredential = "${CI_DEPLOY_CREDENTIAL}" 
        dockerImage = '' 
    }

    
    agent any 
    stages{

        stage('Cloning our Git') { 
            steps {
                git url: "https://github.com/${GITHUB_USER}/${REPO_NAME}.git",
                credentialsId: "${USER_CREDENTIAL}"
                sh "ls -lat"
           }
        }  

        stage('Building our image') { 
            steps { 
                script { 
                    def DOCKER_FILE=  sh(script: 'pwd', , returnStdout: true).trim()
                    dockerImage = docker.build("${CI_DEPLOY_USER}/${APP_IMAGE_NAME}" + ":$BUILD_NUMBER", "-f ${CI_PROJECT_DIR}Dockerfile ${CI_PROJECT_DIR}")
                }
            } 
        }
        stage('Building lb image') { 
                steps { 
                    script { 
                        sh "cd ${CI_PROJECT_DIR_LB}"
                        dockerLBImage = docker.build("${CI_DEPLOY_USER}/${LB_IMAGE_NAME}" + ":$BUILD_NUMBER",  "-f ${CI_PROJECT_DIR_LB}Dockerfile ${CI_PROJECT_DIR_LB}")
                    }
                } 
            }
    
        stage('Deploy our image') { 
            steps { 
                script { 
                    docker.withRegistry( '', registryCredential ) { 
                        dockerImage.push() 
                        dockerLBImage.push() 
                    }
                } 
            }
    
        } 

        stage('Cleaning up') { 
            steps { 
                sh "docker rmi ${CI_DEPLOY_USER}/${APP_IMAGE_NAME}:$BUILD_NUMBER" 
                sh "docker rmi ${CI_DEPLOY_USER}/${LB_IMAGE_NAME}:$BUILD_NUMBER" 
            }
        } 

    }
}